#include "ApplicationSettings.h"

avi::app::ApplicationSettings::ApplicationSettings(avi::core::Settings settings) :
    settings(std::move(settings))
{
}

avi::core::Settings&
avi::app::ApplicationSettings::getSettings()
{
    return settings;
}

const std::string&
avi::app::ApplicationSettings::getStorageIdentifier() const
{
    return settings.storageIdentifier;
}

double
avi::app::ApplicationSettings::getMoveSpeedTechnical() const
{
    return static_cast<double>(settings.moveSpeedTechnical);
}

double
avi::app::ApplicationSettings::getMoveSpeedPlayful() const
{
    return static_cast<double>(settings.moveSpeedPlayful);
}

double
avi::app::ApplicationSettings::getZoomSensitivity() const
{
    return static_cast<double>(settings.zoomSensitivityTechnical);
}

double
avi::app::ApplicationSettings::getOrbitSensitivity() const
{
    return static_cast<double>(settings.orbitSensitivityTechnical);
}

double
avi::app::ApplicationSettings::getRollSensitivity() const
{
    return static_cast<double>(settings.rollSensitivityTechnical);
}

double
avi::app::ApplicationSettings::getMouseSensitivity() const
{
    return static_cast<double>(settings.mouseSensitivityPlayful);
}

double
avi::app::ApplicationSettings::getRevisionCycleFrequency() const
{
    return static_cast<double>(settings.revisionCycleFrequency);
}

const std::string&
avi::app::ApplicationSettings::getDefaultProfileName() const
{
    return settings.defaultProfileName;
}

const std::filesystem::path&
avi::app::ApplicationSettings::getProfileDirectory() const
{
    return settings.profileDirectory;
}

const std::filesystem::path&
avi::app::ApplicationSettings::getScreenshotDirectory() const
{
    return settings.screenshotDirectory;
}

const std::filesystem::path&
avi::app::ApplicationSettings::getVideoDirectory() const
{
    return settings.videoDirectory;
}
double
avi::app::ApplicationSettings::getRollSensitivityPlayful() const
{
    return static_cast<double>(settings.rollSensitivityPlayful);
}
bool
avi::app::ApplicationSettings::cameraGravity() const
{
    return settings.alignCameraToHorizon;
}

