#pragma once

#include <map>
#include <vector>

#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/core/EventSubscriptionSystem.h>

namespace avi::app
{
    class EventList :
        public avi::core::EventSubscriptionSystem,
        public avi::core::EventInvokingSystem
    {
    public:
        ~EventList() override = default;

        void subscribe(std::string event, std::function<void()> callback) override;

        void invoke(const std::string& event) override;

    private:
        std::map<std::string, std::vector<std::function<void()>>> callbacks{};
    };
} // namespace avi::app
