#pragma once

#include <vector>

#include <Godot.hpp>
#include <InputMap.hpp>
#include <Node.hpp>
#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/core/EventToKeyProvider.h>

namespace avi::app
{
    class KeyInputEventDispatch : public godot::Node, public avi::core::EventToKeyProvider
    {
        GODOT_CLASS(KeyInputEventDispatch, Node)

    public:
        virtual ~KeyInputEventDispatch() = default;

        static void _register_methods();

        void _init();

        void _unhandled_input(godot::InputEvent* event);

        void hookup(avi::core::EventInvokingSystem& events);

        std::optional<godot::InputEventKey*>
        getEventKey(std::string const& eventKey) const override;

    private:
        avi::core::EventInvokingSystem* eventSystem = nullptr;

        struct Event
        {
            const char* inputAction;
            const std::string eventKey;
        };

        std::vector<Event> pressedEvents;
        std::vector<Event> releasedEvents;
    };
} // namespace avi::app
