#pragma once

#include <thread>

#include <arviz_godot/lib/avi/connection/Component.h>
#include <arviz_godot/lib/avi/connection/ElementStorage.h>
#include <arviz_godot/lib/avi/connection/MockStorage.h>
#include <arviz_godot/lib/avi/connection/RevisionBuffer.h>
#include <arviz_godot/lib/avi/core/SettingsProvider.h>

namespace avi::app
{
    class RevisionLoadCycle
    {
    public:
        RevisionLoadCycle(avi::connection::Component& component,
                          avi::connection::RevisionBuffer& revisions,
                          const avi::core::SettingsProvider& settings);

        void run(bool mockStorage);

        avi::connection::ElementStorage& getStorage();

        void stop();

    private:
        avi::connection::Component& component;
        avi::connection::RevisionBuffer& revisions;
        const avi::core::SettingsProvider& settings;

        bool running{false};
        std::unique_ptr<avi::connection::ElementStorage> storage{};
        std::thread cycle{};
    };
} // namespace avi::app
