#pragma once

#include <filesystem>
#include <memory>
#include <vector>

#include <String.hpp>
#include <arviz_godot/lib/avi/connection/Clock.h>

namespace avi::connection
{
    class StorageModeSwitch
    {
    public:
        struct recordingInfo
        {
            std::string recordingID;
            int revisionStart;
            int revisionEnd;
            int64_t firstTimeStamp;
            int64_t lastTimeStamp;
            int batches;
        };

        virtual bool isLive() const = 0;

        virtual bool isRecording() const = 0;

        virtual std::string recordReplay(const std::string& name) = 0;

        virtual void endRecording() = 0;

        virtual avi::connection::StorageModeSwitch::recordingInfo
        getRecordingInformation(const std::string name) = 0;

        virtual std::vector<std::string> getAllReplays() = 0;

        virtual std::filesystem::path getRecordingPath() = 0;

        virtual void useLiveTiming() = 0;

        virtual void useReplayTiming(const std::string& replay,
                                     std::shared_ptr<avi::connection::Clock> clock) = 0;

        virtual ~StorageModeSwitch() = default;
    };
} // namespace avi::connection
