#pragma once

#include <map>
#include <optional>

namespace avi::core
{
    template <class K, class V>
    class Cache
    {
    public:
        bool contains(K key);

        void emplace(K key, V value);

        std::optional<V> get(K key);

        void clear();

    private:
        struct Entry
        {
            V value;
            uint64_t lastUse;
        };

        std::map<K, Entry> entries;

        uint32_t counter;

        static const int CACHE_SIZE = 200;
    };
} // namespace avi::core

#include "Cache.tpp"
