#include "Utilities.h"

real_t
avi::core::utilities::signed_angle(const godot::Vector3& from,
                                   const godot::Vector3& to,
                                   const godot::Vector3& axis)
{
    godot::Vector3 cross_to = from.cross(to);
    real_t unsigned_angle = godot::Math::atan2(cross_to.length(), from.dot(to));
    real_t sign = cross_to.dot(axis);
    return (sign < 0) ? -unsigned_angle : unsigned_angle;
}

godot::Basis
avi::core::utilities::scaled_local(const godot::Basis& basis, const godot::Vector3& scale)
{
    return basis * godot::Basis(scale.x, 0, 0, 0, scale.y, 0, 0, 0, scale.z);
}

bool
avi::core::utilities::is_equal_approx(const godot::Vector3 a, const godot::Vector3 b)
{
    return godot::Math::is_equal_approx(a.x, b.x) && godot::Math::is_equal_approx(a.y, b.y) &&
           godot::Math::is_equal_approx(a.z, b.z);
}

void
avi::core::utilities::print(const std::string& text)
{
    godot::Godot::print(text.c_str());
}
