#pragma once

#include <arviz_godot/lib/avi/core/Option.h>

namespace avi::core
{
    template <typename V, typename T>
    class ValueOption : public Option<T>
    {
    public:
        ValueOption(std::string key, std::string label, V& value, std::string tooltip = "");

        void accept(T& transformer) override;

        void setValue(V value);

        const V& getValue();

    private:
        V& value;
    };
} // namespace avi::core

#include "ValueOption.tpp"
