#include "OrientationWindow.h"

#include <Button.hpp>

void
avi::gui::OrientationWindow::_register_methods()
{
    register_method("_ready", &OrientationWindow::_ready);
    register_method("_ok", &OrientationWindow::_ok);
}

void
avi::gui::OrientationWindow::_init()
{
}

void
avi::gui::OrientationWindow::_ready()
{
    x = get_node<godot::SpinBox>("Container/Values/X");
    y = get_node<godot::SpinBox>("Container/Values/Y");
    z = get_node<godot::SpinBox>("Container/Values/Z");

    get_node<godot::Button>("Container/Center/Accept")->connect("pressed", this, "_ok");
}

void
avi::gui::OrientationWindow::setup(avi::scene::VisualizedScene& scene)
{
    this->scene = &scene;
}

void
avi::gui::OrientationWindow::open()
{
    godot::Vector3 orientation = scene->getOrientation();

    x->set_value(orientation.x);
    y->set_value(orientation.y);
    z->set_value(orientation.z);

    this->popup_centered();
}

void
avi::gui::OrientationWindow::_ok()
{
    godot::Vector3 orientation(x->get_value(), y->get_value(), z->get_value());
    scene->setOrientation(orientation);

    this->hide();
}
