#pragma once

#include <Godot.hpp>
#include <SpinBox.hpp>
#include <WindowDialog.hpp>
#include <arviz_godot/lib/avi/scene/VisualizedScene.h>

namespace avi::gui
{
    class OrientationWindow : public godot::WindowDialog
    {
        GODOT_CLASS(OrientationWindow, godot::WindowDialog)

    public:
        virtual ~OrientationWindow() = default;

        static void _register_methods();

        void _init();

        void _ready();

    public:
        void setup(avi::scene::VisualizedScene& scene);

        void open();

    private:
        void _ok();

    private:
        godot::SpinBox* x;
        godot::SpinBox* y;
        godot::SpinBox* z;

        avi::scene::VisualizedScene* scene;
    };
} // namespace avi::gui
