#include "SelectionMenu.h"

#include <GlobalConstants.hpp>
#include <InputEventMouseButton.hpp>

void
avi::gui::SelectionMenu::_register_methods()
{
    godot::register_method("_ready", &avi::gui::SelectionMenu::_ready);
    godot::register_method("sendInteraction", &avi::gui::SelectionMenu::sendInteraction);
}

void
avi::gui::SelectionMenu::_init()
{
}

void
avi::gui::SelectionMenu::_ready()
{
    this->connect("id_pressed", this, "sendInteraction");
}

void
avi::gui::SelectionMenu::open(godot::Vector2 mousePosition,
                              std::vector<std::string>& options,
                              std::function<void(int64_t)> callback)
{
    this->callback = callback;

    if (this->options == options)
    {
        popup(godot::Rect2(mousePosition.x, mousePosition.y, 10, 10));
        return;
    }

    this->clear();
    this->options = options;

    popup(godot::Rect2(mousePosition.x, mousePosition.y, 10, 10));

    for (auto& option : options)
    {
        this->add_item(option.c_str());
    }

    this->set_size({0, 0});
}

void
avi::gui::SelectionMenu::sendInteraction()
{
    int64_t index = this->get_current_index();
    if (index < 0)
    {
        return;
    }

    size_t idx = index;

    if (idx < options.size())
    {
        this->callback(this->get_current_index());
    }
}
