#pragma once

#include <Godot.hpp>
#include <WindowDialog.hpp>
#include <arviz_godot/lib/avi/core/Settings.h>
#include <arviz_godot/lib/avi/gui/VisualOptionTransformer.h>

namespace avi::gui
{
    class SettingsWindow : public godot::WindowDialog
    {
        GODOT_CLASS(SettingsWindow, godot::WindowDialog)

    public:
        virtual ~SettingsWindow() = default;

        static void _register_methods();

        void _init();

    public:
        void setup(avi::core::Settings& settings);

        void open();

    private:
        void _change(godot::Variant v);

        void _save();

        void setSavedFlag(bool flag);

    private:
        godot::Button* saveButton{};

        avi::core::Settings* settings{};
        std::vector<std::unique_ptr<avi::core::Option<VisualOptionTransformer>>> options{};
        std::vector<std::function<void()>> setters{};
    };
} // namespace avi::gui
