#pragma once

#include <Godot.hpp>
#include <Spatial.hpp>
#include <arviz_godot/lib/avi/interaction/MoveAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class Move : public godot::Spatial
    {
        GODOT_CLASS(Move, Spatial)

    public:
        virtual ~Move() = default;

        static void _register_methods();

        void _init();

        void _process(float delta);

        void setup(avi::interaction::Manipulator& manipulator, godot::Spatial* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

        void updateTransform(const godot::Transform& global);
        void updateRelease();

        godot::Spatial* get_proxy();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Spatial* proxy;

        avi::scene::ElementNode* elementNode{};

        avi::interaction::MoveAxisGizmo* XAxisGizmo{};
        avi::interaction::MoveAxisGizmo* YAxisGizmo{};
        avi::interaction::MoveAxisGizmo* ZAxisGizmo{};

        enum axis
        {
            xAxis = 0,
            yAxis = 1,
            zAxis = 2
        };
    };
} // namespace avi::interaction
