#pragma once

#include <Godot.hpp>
#include <Spatial.hpp>
#include <arviz_godot/lib/avi/interaction/RotateAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class Rotate : public godot::Spatial
    {
        GODOT_CLASS(Rotate, Spatial)

    public:
        virtual ~Rotate() = default;

        static void _register_methods();

        void _init();

        void setup(avi::interaction::Manipulator& manipulator, godot::Spatial* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

        void updateTransform(const godot::Transform& local);
        void updateRelease();

        godot::Spatial* get_proxy();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Spatial* proxy{};

        avi::scene::ElementNode* elementNode{};

        avi::interaction::RotateAxisGizmo* XAxisGizmo{};
        avi::interaction::RotateAxisGizmo* YAxisGizmo{};
        avi::interaction::RotateAxisGizmo* ZAxisGizmo{};
    };
} // namespace avi::interaction
