#pragma once

#include <Godot.hpp>
#include <Spatial.hpp>
#include <arviz_godot/lib/avi/interaction/ScaleAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class Scale : public godot::Spatial
    {
        GODOT_CLASS(Scale, Spatial)

    public:
        virtual ~Scale() = default;

        static void _register_methods();

        void _init();

        void _process(float delta);

        void setup(avi::interaction::Manipulator& manipulator, godot::Spatial* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

        void updateTransform(const godot::Transform& global, const godot::Transform& local);
        void updateRelease();

        godot::Spatial* get_proxy();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Spatial* proxy{};

        avi::scene::ElementNode* elementNode{};

        avi::interaction::ScaleAxisGizmo* XAxisGizmo{};
        avi::interaction::ScaleAxisGizmo* YAxisGizmo{};
        avi::interaction::ScaleAxisGizmo* ZAxisGizmo{};

        godot::Vector3 scale = {};

        enum axis
        {
            xAxis = 0,
            yAxis = 1,
            zAxis = 2
        };
    };
} // namespace avi::interaction
