#pragma once

#include "MeshElementNode.h"
#include <CubeMesh.hpp>

namespace avi::scene
{
    class CubeElementNode : public avi::scene::MeshElementNode
    {
        GODOT_CLASS(CubeElementNode, ElementNode)

    public:
        ~CubeElementNode() override = default;

        static void _register_methods();

        void _ready();

        void _init();

        static avi::scene::CubeElementNode* newCubeElementNode(std::string name,
                                                               avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        godot::Vector3 size;
    };
} // namespace avi::scene
