#pragma once

#include <CubeMesh.hpp>
#include <arviz_godot/lib/avi/scene/MeshElementNode.h>

namespace avi::scene
{
    class CustomMeshElementNode : public avi::scene::MeshElementNode
    {
        GODOT_CLASS(CustomMeshElementNode, ElementNode)

    public:
        ~CustomMeshElementNode() override = default;

        static void _register_methods();

        void _ready();

        void _init();

        static CustomMeshElementNode*
        newCustomMeshElementNode(godot::Mesh* mesh,
                                 avi::connection::SentElementType type,
                                 std::string name,
                                 avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        bool first = true;
    };
} // namespace avi::scene
