#pragma once

#include "ElementNode.h"
#include <Dictionary.hpp>
#include <Godot.hpp>
#include <PhysicsDirectSpaceState.hpp>
#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/scene/CameraControlScheme.h>
#include <arviz_godot/lib/avi/scene/PoseElementNode.h>
#include <arviz_godot/lib/avi/scene/VisualizedScene.h>

namespace avi::scene
{
    class OrientationIndicator : public godot::Viewport
    {
        GODOT_CLASS(OrientationIndicator, godot::Viewport)

    public:
        OrientationIndicator();
        ~OrientationIndicator() = default;

        void _init();

        static void _register_methods();

        void _process();

        void _ready();

        void selectElement();

        void _input(godot::InputEvent* event);

        void _unhandled_input(godot::InputEvent* event);

        void setup(avi::scene::VisualizedScene* scene,
                   avi::scene::ViewCamera* viewCamera,
                   avi::core::EventInvokingSystem& events);

    private:
        struct OrientationIndicatorPoint
        {
            godot::Spatial* spatial;
            CameraControlScheme::Axis axis;
        };

        avi::scene::VisualizedScene* scene;
        avi::scene::ViewCamera* viewCamera;
        godot::Camera* camera;
        godot::StaticBody* pose;

        std::vector<OrientationIndicatorPoint> points{};

        avi::core::EventInvokingSystem* events = nullptr;
    };
} // namespace avi::scene
