#include "PolygonElementNode.h"

#include "Converter.h"

void
avi::scene::PolygonElementNode::_register_methods()
{
    register_method("_ready", &PolygonElementNode::_ready);
}

void
avi::scene::PolygonElementNode::_ready()
{
    ;
}

void
avi::scene::PolygonElementNode::_init()
{
    ;
}

void
avi::scene::PolygonElementNode::update(IceInternal::Handle<armarx::viz::data::Element> elementInfo)
{
    auto polygon = IceInternal::Handle<armarx::viz::data::ElementPolygon>::dynamicCast(elementInfo);
    godot::ArrayMesh* mesh1 = godot::Object::cast_to<godot::ArrayMesh>(getMesh(0));
    godot::ArrayMesh* mesh2 = godot::Object::cast_to<godot::ArrayMesh>(getMesh(1));
    godot::PoolVector3Array coords;
    godot::PoolVector3Array normals;
    godot::Vector3 normal = avi::scene::Converter::getNormal(
        polygon->points.at(0), polygon->points.at(1), polygon->points.at(2));
    for (auto& vertex : polygon->points)
    {
        coords.push_back(godot::Vector3(vertex.e0, vertex.e1, vertex.e2));
        normals.push_back(normal);
    }
    godot::Array arr{};
    arr.resize(godot::ArrayMesh::ARRAY_MAX);
    arr[godot::ArrayMesh::ARRAY_VERTEX] = coords;
    arr[godot::ArrayMesh::ARRAY_NORMAL] = normals;
    mesh1->clear_surfaces();
    mesh2->clear_surfaces();
    mesh1->add_surface_from_arrays(godot::Mesh::PRIMITIVE_TRIANGLE_FAN, arr);
    mesh2->add_surface_from_arrays(godot::Mesh::PRIMITIVE_LINE_LOOP, arr);
    updateAttributes(polygon->interaction.enableFlags,
                     polygon->interaction.contextMenuOptions,
                     avi::scene::Converter::getPosition(polygon->pose),
                     avi::scene::Converter::getScale(polygon->scale),
                     avi::scene::Converter::getRotation(polygon->pose),
                     avi::scene::Converter::getColor(polygon->color));

    setTwoSided(0);
    setColor(avi::scene::Converter::getColor(polygon->lineColor), 1);
    if (polygon->lineWidth <= 0)
    {
        setVisibility(1, false);
    }
    else
    {
        setVisibility(1, true);
    }
}

avi::scene::PolygonElementNode*
avi::scene::PolygonElementNode::newPolygonElementNode(std::vector<godot::Mesh*> mesh,
                                                      avi::connection::SentElementType type,
                                                      std::string name,
                                                      avi::core::Layer* layer)
{
    PolygonElementNode* node = PolygonElementNode::_new();
    node->setStartAttributes(mesh, type, name, layer);
    return node;
}
