#include "Profile.h"

const std::string&
avi::scene::Profile::getName()
{
    return name;
}

void
avi::scene::Profile::rename(const std::string& name)
{
    this->name = name;
}

void
avi::scene::Profile::writeToFile(avi::core::OptionFile& optionFile)
{
    avi::core::OptionFileWriter<avi::scene::Profile> writer(*this);
    writer.write(optionFile);

    optionFile.setName(name);
}

avi::scene::Profile
avi::scene::Profile::readFromFile(avi::core::OptionFile& optionFile)
{
    avi::scene::Profile profile;
    profile.rename(optionFile.getName());

    avi::core::OptionFileReader<avi::scene::Profile> reader(profile);
    reader.read(optionFile);

    return profile;
}
