#include "avi/app/KeyInputEventDispatch.h"
#include "avi/app/Main.h"
#include "avi/gui/GraphicsSettings.h"
#include "avi/gui/LayerSelection.h"
#include "avi/gui/ManipulationMenu.h"
#include "avi/gui/OrientationWindow.h"
#include "avi/gui/ReplayCockpit.h"
#include "avi/gui/SelectionMenu.h"
#include "avi/gui/SettingsWindow.h"
#include "avi/gui/StatusIcons.h"
#include "avi/gui/UserInterface.h"
#include "avi/interaction/InteractionDispatch.h"
#include "avi/interaction/Move.h"
#include "avi/interaction/MoveAxisGizmo.h"
#include "avi/interaction/None.h"
#include "avi/interaction/Rotate.h"
#include "avi/interaction/RotateAxisGizmo.h"
#include "avi/interaction/Scale.h"
#include "avi/interaction/ScaleAxisGizmo.h"
#include "avi/scene/ArrowCircleElementNode.h"
#include "avi/scene/ArrowElementNode.h"
#include "avi/scene/CubeElementNode.h"
#include "avi/scene/LayerNode.h"
#include "avi/scene/ObjectElementNode.h"
#include "avi/scene/OrientationIndicator.h"
#include "avi/scene/PlayfulControlScheme.h"
#include "avi/scene/PointCloudElementNode.h"
#include "avi/scene/PoseElementNode.h"
#include "avi/scene/RobotElementNode.h"
#include "avi/scene/SphereElementNode.h"
#include "avi/scene/TechnicalControlScheme.h"
#include "avi/scene/TextElementNode.h"
#include "avi/scene/ViewCamera.h"
#include "avi/scene/VisualizedScene.h"
#include <Godot.hpp>
#include <arviz_godot/lib/avi/gui/CameraModeMenu.h>
#include <arviz_godot/lib/avi/scene/CustomMeshElementNode.h>
#include <arviz_godot/lib/avi/scene/CylinderElementNode.h>
#include <arviz_godot/lib/avi/scene/CylindroidElementNode.h>
#include <arviz_godot/lib/avi/scene/EllipsoidElementNode.h>
#include <arviz_godot/lib/avi/scene/LineElementNode.h>
#include <arviz_godot/lib/avi/scene/PathElementNode.h>
#include <arviz_godot/lib/avi/scene/PolygonElementNode.h>

extern "C" void GDN_EXPORT
godot_gdnative_init(godot_gdnative_init_options* o)
{
    godot::Godot::gdnative_init(o);
}

extern "C" void GDN_EXPORT
godot_gdnative_terminate(godot_gdnative_terminate_options* o)
{
    godot::Godot::gdnative_terminate(o);
}

extern "C" void GDN_EXPORT
godot_nativescript_init(void* handle)
{
    godot::Godot::nativescript_init(handle);

    godot::register_class<avi::app::KeyInputEventDispatch>();
    godot::register_class<avi::app::Main>();

    godot::register_class<avi::gui::GraphicsSettings>();
    godot::register_class<avi::gui::LayerSelection>();
    godot::register_class<avi::gui::ManipulationMenu>();
    godot::register_class<avi::gui::ReplayCockpit>();
    godot::register_class<avi::gui::SelectionMenu>();
    godot::register_class<avi::gui::SettingsWindow>();
    godot::register_class<avi::gui::StatusIcons>();
    godot::register_class<avi::gui::UserInterface>();
    godot::register_class<avi::gui::CameraModeMenu>();
    godot::register_class<avi::gui::OrientationWindow>();

    godot::register_class<avi::interaction::InteractionDispatch>();
    godot::register_class<avi::interaction::Move>();
    godot::register_class<avi::interaction::Rotate>();
    godot::register_class<avi::interaction::Scale>();
    godot::register_class<avi::interaction::None>();
    godot::register_class<avi::interaction::MoveAxisGizmo>();
    godot::register_class<avi::interaction::RotateAxisGizmo>();
    godot::register_class<avi::interaction::ScaleAxisGizmo>();

    godot::register_class<avi::scene::LayerNode>();
    godot::register_class<avi::scene::ElementNode>();
    godot::register_class<avi::scene::ObjectElementNode>();
    godot::register_class<avi::scene::PlayfulControlScheme>();
    godot::register_class<avi::scene::RobotElementNode>();
    godot::register_class<avi::scene::TechnicalControlScheme>();
    godot::register_class<avi::scene::TextElementNode>();
    godot::register_class<avi::scene::ArrowElementNode>();
    godot::register_class<avi::scene::ArrowCircleElementNode>();
    godot::register_class<avi::scene::PoseElementNode>();
    godot::register_class<avi::scene::ViewCamera>();
    godot::register_class<avi::scene::VisualizedScene>();
    godot::register_class<avi::scene::PointCloudElementNode>();
    godot::register_class<avi::scene::OrientationIndicator>();
    godot::register_class<avi::scene::CubeElementNode>();
    godot::register_class<avi::scene::SphereElementNode>();
    godot::register_class<avi::scene::CylinderElementNode>();
    godot::register_class<avi::scene::EllipsoidElementNode>();
    godot::register_class<avi::scene::CylindroidElementNode>();
    godot::register_class<avi::scene::LineElementNode>();
    godot::register_class<avi::scene::PathElementNode>();
    godot::register_class<avi::scene::CustomMeshElementNode>();
    godot::register_class<avi::scene::PolygonElementNode>();
}
