extends MeshInstance

export var mat: Material

var vertices: PoolVector3Array
var colors: PoolColorArray

func _ready():
	vertices = PoolVector3Array()
	colors = PoolColorArray()
	
	var small = 1.0
	var large = 1000.0
	
	add_line(Vector3(-large, 0, 0), Vector3(small, 0, 0), Color.red)
	add_line(Vector3(-small, 0, 0), Vector3(small, 0, 0), Color.red)
	add_line(Vector3(small, 0, 0), Vector3(large, 0, 0), Color.red)
	
	add_line(Vector3(0, -large, 0), Vector3(0, small, 0), Color.green)
	add_line(Vector3(0, -small, 0), Vector3(0, small, 0), Color.green)
	add_line(Vector3(0, small, 0), Vector3(0, large, 0), Color.green)
	
	add_line(Vector3(0, 0, -large), Vector3(0, 0, small), Color.blue)
	add_line(Vector3(0, 0, -small), Vector3(0, 0, small), Color.blue)
	add_line(Vector3(0, 0, small), Vector3(0, 0, large), Color.blue)
	
	var arrays = []
	arrays.resize(ArrayMesh.ARRAY_MAX)
	arrays[ArrayMesh.ARRAY_VERTEX] = vertices
	arrays[ArrayMesh.ARRAY_COLOR] = colors
	
	var array_mesh = ArrayMesh.new()
	array_mesh.add_surface_from_arrays(Mesh.PRIMITIVE_LINES, arrays)
	array_mesh.surface_set_material(0, mat)
	
	self.mesh = array_mesh

func add_line(from: Vector3, to: Vector3, color: Color):
	vertices.push_back(from)
	vertices.push_back(to)
	colors.push_back(color)
	colors.push_back(color)
